local metadata = {
"## Interface: 2.1.0.2 RC3",
"## Title: BlinkLichtPlace",
"## Notes: BlinkLichtPlace",
"## Author: Marhu",
"## Version: 0.0.04a",
"## Date: 07.10.2014",
}

BlinkLichtPlace = {};
BlinkLichtPlace_mt = Class(BlinkLichtPlace, Placeable);
InitObjectClass(BlinkLichtPlace, "BlinkLichtPlace");

function BlinkLichtPlace:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, BlinkLichtPlace_mt);
    registerObjectClassName(self, "BlinkLichtPlace");
	
	return self;
end;

function BlinkLichtPlace:delete()
  	unregisterObjectClassName(self);
    BlinkLichtPlace:superClass().delete(self);
end;

function BlinkLichtPlace:deleteFinal()
    BlinkLichtPlace:superClass().deleteFinal(self);
end;

function BlinkLichtPlace:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not BlinkLichtPlace:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;

	if not moveMode then
		local xmlFile = loadXMLFile("TempXML", xmlFilename);
		local lichtGroup = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.LichtIndex#Index"));
		self.interval = Utils.getNoNil(getXMLFloat(xmlFile, "placeable.interval#value"),  1000);
		self.Licht = {}
		if lichtGroup then
			local numChildren = getNumOfChildren(lichtGroup);
			for i=1,numChildren do
				local licht = {}
				licht.node = getChildAt(lichtGroup, i-1);
				licht.elaps = 0
				licht.maxelaps = math.random(self.interval*.95,self.interval*1.05)
				table.insert(self.Licht,licht)
			end
		end
		delete(xmlFile);
	end
  
	return true;
end;

function BlinkLichtPlace:update(dt)
	for i=1,table.getn(self.Licht) do
		self.Licht[i].elaps = self.Licht[i].elaps + dt
		if self.Licht[i].elaps >= self.Licht[i].maxelaps then
			setVisibility(self.Licht[i].node,not getVisibility(self.Licht[i].node));
			self.Licht[i].elaps = 0
		end
	end
end;

registerPlaceableType("BlinkLichtPlace", BlinkLichtPlace);